<template>
  <q-card square bordered dark flat class="q-my-xl">
    <q-card-section class="col-12 text-center">
      <FormSectionTitle
        title="Membres"
        subtitle="Breu descripció dels membres"
      ></FormSectionTitle>
    </q-card-section>
    <q-card-section class="col-12 col-md-10 offset-md-1 justfy-center row">
      <q-card-section class="col-12 q-py-md">
        <!-- IMAGES -->
        <q-file
          v-model="savedPhotos"
          use-chips
          standout
          dark
          label="Puja Imatges (Màxim 3)"
          multiple
          max-files="3"
          @rejected="onRejected"
          @update:model-value="addImages"
          hint="Perfils amb fotos tenen més bona acollida"
        >
          <template v-slot:prepend>
            <q-icon name="upload" />
          </template>
        </q-file>

        <Carousel v-if="photos.length" :photos="photos" />
      </q-card-section>

      <!-- Form -->
      <q-card-section class="col-12 no-padding">
        <q-card-section>
          <q-input
            square
            dark
            outlined
            v-model="member.name"
            type="text"
            label="Nom*"
          />
        </q-card-section>
        <q-card-section class="col-12">
          <q-input
            square
            dark
            outlined
            v-model="member.birthDate"
            type="text"
            mask="##/##/####"
            fill-mask="#"
            hint="DD/MM/AAAA"
            label="Data de Naixement*"
            required
          />
        </q-card-section>
        <q-card-section>
          <q-select
            emit-value
            map-options
            square
            dark
            outlined
            v-model="member.gender"
            label="Gènere *"
            required
            :options="GENDERS"
          />
        </q-card-section>
        <q-card-section>
          <q-input
            square
            dark
            outlined
            v-model="member.guild"
            type="text"
            label="Ofici"
          />
        </q-card-section>

        <!-- ADD MEMBER -->
        <q-card-section class="row col-12 justify-center">
          <q-btn
            class="full-width"
            unelevated
            square
            color="primary"
            icon="add"
            label="Afegeix membre"
            @click="addMember"
            :disable="!member.name || !member.birthDate || !member.gender"
          />
        </q-card-section>
      </q-card-section>

      <!-- Members -->
      <q-card-section v-if="members.length" class="col-12 q-py-md">
        <!-- <h1 class="no-margin">Membres:</h1> -->
        <FormSectionTitle title="Membres"></FormSectionTitle>
        <q-list separator>
          <q-item v-for="(member, index) in members" :key="index">
            <q-item-section avatar> {{ getAge(member) }} anys </q-item-section>
            <q-item-section>
              {{ member.name }}
            </q-item-section>
            <q-item-section class="gt-sm">
              {{ member.guild }}
            </q-item-section>
            <q-item-section @click="removeMember(index)" avatar>
              <q-icon color="primary" :name="member.gender" />
            </q-item-section>
            <q-item-section @click="removeMember(index)" avatar>
              <q-icon color="red" name="clear" />
            </q-item-section>
          </q-item>
        </q-list>
      </q-card-section>
    </q-card-section>
  </q-card>
</template>

<script setup lang="ts">
import { ref } from 'vue'
import { useQuasar } from 'quasar'
import { storeToRefs } from 'pinia'
import { date } from 'quasar'

import FormSectionTitle from 'src/components/mxv/FormSectionTitle.vue'
import Carousel from 'src/components/shared/Carousel.vue'
import { Member } from '../models'
import { useUCStore, getAge } from 'src/stores/UCprofile'

const GENDERS = [
  {
    label: 'Dona',
    value: 'female',
  },
  {
    label: 'Home',
    value: 'male',
  },
  {
    label: 'Altres',
    value: 'transgender',
  },
]

/**
 * UC PROFILE STORE
 */
const store = useUCStore()
const { members, photos } = storeToRefs(store)

/**
 * COMPONENT STATE
 */
const $q = useQuasar()
const member = ref({} as Member)
const savedPhotos = ref<File[]>()

/**
 * EXPOSE to PARENT
 */
const uploader = ref()
defineExpose({
  uploader,
})

/***********************/
/* @Methods:
 ************************/

/**
 * Add Imgs to Central State
 */
const addImages = (): void => {
  store.$patch(() => {
    photos.value = []

    if (savedPhotos.value?.length) {
      savedPhotos.value.forEach((file: File): void => {
        photos.value.push(URL.createObjectURL(file))
      })
    }
  })
}

/**
 * Notify error from image upload
 * @param rejectedEntries Array of files that caused an error
 */
const onRejected = (rejectedEntries: object[]): void => {
  console.log(rejectedEntries)
  $q.notify({
    type: 'negative',
    message: '3 imatges màxim',
  })
}

const resetMember = (): void => {
  member.value = {} as Member //Could be this way as well =>  member.value = <Member>{}
}

/**
 * Add members to Central State
 */
const addMember = (): void => {
  member.value.birthDate = date.extractDate(
    member.value.birthDate.toString(),
    'DD/MM/YYYY'
  )

  members.value.push(member.value)
  resetMember()
}

/**
 * Remove the selected member
 * @param index number
 */
const removeMember = (index: number): void => {
  members.value.splice(index, 1)
}
</script>
